package jp.co.y_net.amm.dao;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Example;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Component;


@Component("grpDao")
public class GrpDao extends AbstractDao {
    
    /* 参照形処理 ------------------------------------------------------------------------------------------------ */
    /** ユニークキーを使用した取得 */
    public Grp getByGrpid(Integer grpid) {
        Grp cnd = new Grp();
        cnd.setGrpid(grpid);
        List<Grp> list = get(cnd);
        if(list.size() == 1) {
            return list.get(0);
        }
        return null;
    }
    /** 全件取得(論理削除除外) */
    public List<Grp> get() {
        Grp cnd = new Grp();
        cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        return get(cnd);
    }
    /** 条件付き取得(論理削除除外) */
    public List<Grp> get(Grp cnd) {
        if(cnd != null) {
            cnd.setDeleted(AppDef.FLASE); // 論理削除考慮
        }
        HibernateTemplate hibernateTemplate = getHibernateTemplate();
        DetachedCriteria dc = DetachedCriteria.forClass(Grp.class);
        dc.add(Example.create(cnd));
        @SuppressWarnings("unchecked")
        List<Grp> list = (List<Grp>) hibernateTemplate.findByCriteria(dc);
        hibernateTemplate.clear();
        return list;
    }
    
    /* 更新系処理 ------------------------------------------------------------------------------------------------ */
    private static final String ENTITYNAME = "Grp";
    private static final String PKEYNAME = "grpid";
    /**
     * 登録処理
     * ・必要なカラムを自動採番する
     * ・共通処理を実施する。
     * @see AbstractDao#add(AppDto, Integer)
     * @param item 追加対象オブジェクト
     * @param updateusrid 更新者ID
     */
    public void add(Grp item, Integer updateusrid) {
        /* 自動採番 */
        item.setGrpid(getNextId(ENTITYNAME, PKEYNAME, 1000000001)); // グループIDとユーザIDの重複を避けるため、開始する値を変更する。
        /* Insert実施 */
        super.add(item, updateusrid);
    }

    public void update(Grp item, Integer updateusrid) {
        super.update(item, updateusrid);
    }
    public void removeLogical(Grp item, Integer updateusrid) {
        super.removeLogical(item, updateusrid);
    }
}
